# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetTransformationsResult',
    'AwaitableGetTransformationsResult',
    'get_transformations',
    'get_transformations_output',
]

@pulumi.output_type
class GetTransformationsResult:
    """
    A collection of values returned by getTransformations.
    """
    def __init__(__self__, id=None, transformations=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if transformations and not isinstance(transformations, list):
            raise TypeError("Expected argument 'transformations' to be a list")
        pulumi.set(__self__, "transformations", transformations)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def transformations(self) -> Optional[Sequence['outputs.GetTransformationsTransformationResult']]:
        return pulumi.get(self, "transformations")


class AwaitableGetTransformationsResult(GetTransformationsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetTransformationsResult(
            id=self.id,
            transformations=self.transformations)


def get_transformations(transformations: Optional[Sequence[Union['GetTransformationsTransformationArgs', 'GetTransformationsTransformationArgsDict']]] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetTransformationsResult:
    """
    Returns a list of all transformations available via API within your Fivetran account.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_fivetran as fivetran

    test = fivetran.get_transformations()
    ```
    """
    __args__ = dict()
    __args__['transformations'] = transformations
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('fivetran:index/getTransformations:getTransformations', __args__, opts=opts, typ=GetTransformationsResult).value

    return AwaitableGetTransformationsResult(
        id=pulumi.get(__ret__, 'id'),
        transformations=pulumi.get(__ret__, 'transformations'))
def get_transformations_output(transformations: Optional[pulumi.Input[Optional[Sequence[Union['GetTransformationsTransformationArgs', 'GetTransformationsTransformationArgsDict']]]]] = None,
                               opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetTransformationsResult]:
    """
    Returns a list of all transformations available via API within your Fivetran account.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_fivetran as fivetran

    test = fivetran.get_transformations()
    ```
    """
    __args__ = dict()
    __args__['transformations'] = transformations
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('fivetran:index/getTransformations:getTransformations', __args__, opts=opts, typ=GetTransformationsResult)
    return __ret__.apply(lambda __response__: GetTransformationsResult(
        id=pulumi.get(__response__, 'id'),
        transformations=pulumi.get(__response__, 'transformations')))
